import { IBotController, IBotSettings, IBotUser, IBotReply, IBotReplyListItemAction, IBotReplyListItem } from '../interfaces';
import { IFbCallback, IFbMessaging } from './interfaces';
import { FacebookApi } from './api';
import * as Promise from 'bluebird';
export declare class FacebookReply implements IBotReply {
    private recipientId;
    private fbApi;
    constructor(recipientId: number, fbApi: FacebookApi);
    text(text: string): Promise<any>;
    list(elements: Array<IBotReplyListItem>): Promise<any>;
    buttons(text: string, buttons: IBotReplyListItemAction[]): Promise<any>;
}
export declare class FacebookBot {
    private settings;
    private botController;
    profiles: Object;
    fbApi: FacebookApi;
    constructor(settings: IBotSettings, botController: IBotController);
    receiveMessage(fbMessage: IFbCallback): Promise<any>;
    dispatchSingleMessage(messaging: IFbMessaging, user: IBotUser): void;
    private dispatchAttachmentMessage(messaging, user);
    private getUserProfile(userId);
    private getUserFromMessage(messaging);
}
