import { ICoordinates } from '../interfaces';
export declare class FB_MESSAGE_TYPE {
    static PAGE: string;
}
export declare class FB_ATTACHMENT_TYPE {
    static IMAGE: string;
    static VIDEO: string;
    static AUDIO: string;
    static LOCATION: string;
    static FALLBACK: string;
}
export interface IFbMessageUser {
    id: number;
}
export interface IFbMessageAttachmentPayload {
    url?: string;
    coordinates?: ICoordinates;
}
export interface IFbMessageAttachment {
    type: FB_ATTACHMENT_TYPE;
    url?: string;
    title?: string;
    payload?: IFbMessageAttachmentPayload;
}
export interface IFbMessage {
    mid: string;
    seq: number;
    text?: string;
    attachments?: Array<IFbMessageAttachment>;
}
export interface IFbMessageOptin {
    ref: string;
}
export interface IFbPostbackPayload {
    payload: string;
}
export interface IFbMessaging {
    sender: IFbMessageUser;
    recipient: IFbMessageUser;
    timestamp: number;
    message?: IFbMessage;
    optin?: IFbMessageOptin;
    delivery?: Object;
    postback?: IFbPostbackPayload;
}
export interface IFbMessageEntry {
    id: number;
    time: number;
    messaging: IFbMessaging[];
}
export interface IFbCallback {
    object: FB_MESSAGE_TYPE;
    entry: IFbMessageEntry[];
}
export declare class FB_RESPONSE_ATTACHMENT_TYPE {
    static TEMPLATE: string;
    static IMAGE: string;
}
export declare class FB_RESPONSE_ATTACHMENT_PAYLOAD_TYPE {
    static GENERIC: string;
    static BUTTON: string;
    static RECEIPT: string;
}
export declare class BOT_REPLY_LIST_ACTION_TYPE {
    static LINK: string;
    static POSTBACK: string;
}
export interface IFbResponseAttachmentPayloadElementAction {
    title: string;
    url?: string;
    payload?: string;
    type: BOT_REPLY_LIST_ACTION_TYPE;
}
export interface IFbResponseAttachmentPayloadElement {
    title: string;
    item_url?: string;
    image_url?: string;
    subtitle?: string;
    buttons?: Array<IFbResponseAttachmentPayloadElementAction>;
}
export interface IFbResponseAttachmentPayload {
    template_type: FB_RESPONSE_ATTACHMENT_PAYLOAD_TYPE;
    elements?: Array<IFbResponseAttachmentPayloadElement>;
    text?: string;
    buttons?: Array<IFbResponseAttachmentPayloadElementAction>;
    recipient_name?: string;
    order_number?: string;
    currency?: string;
    payment_method?: string;
    timestamp?: string;
    order_url?: string;
    address?: Object;
    summary?: Object;
    adjustments?: Object;
}
export interface IFbResponseAttachment {
    type: FB_RESPONSE_ATTACHMENT_TYPE;
    payload: IFbResponseAttachmentPayload;
}
export interface IFbResponseMessage {
    text?: string;
    attachment?: IFbResponseAttachment;
}
export interface IFbResponse {
    recipient: IFbMessageUser;
    message?: IFbResponseMessage;
}
